/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.sample;

import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Remote;
import javax.ejb.Remove;
import javax.ejb.Stateful;

/**
 *
 * @author ricky
 */
@Stateful(name="SampleBean")
@Remote(Sample.class)
public class SampleBean implements Sample, Serializable {

    private int count = 0;
    
    @PostConstruct
    public void ejbStartup() {
        System.err.println(this + " - Created!!!! count=" + count);
    }
    
    @PreDestroy
    public void ejbShutdown() {
        System.err.println(this + " - Destoyed!!!! count=" + count);
    }
     
    @Override
    public String increment() {
        return new StringBuilder(System.getProperty("com.sun.aas.instanceName"))
                .append(": ")
                .append(++count)
                .toString();
    }

    @Override
    public String reset() {
        count = 0;
        return new StringBuilder(System.getProperty("com.sun.aas.instanceName"))
                .append(": reset to ")
                .append(count)
                .toString();
    }

    @Override
    @Remove
    public String stop() {
        return new StringBuilder(System.getProperty("com.sun.aas.instanceName"))
                .append(": releasing count on ")
                .append(count)
                .toString();
    }
    
}
